VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmIniFile 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "IniFile Class"
   ClientHeight    =   6495
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   10845
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6495
   ScaleWidth      =   10845
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.TextBox Text4 
      Height          =   315
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   13
      Top             =   5760
      Width           =   3135
   End
   Begin RichTextLib.RichTextBox RichTextBox1 
      Height          =   5535
      Left            =   6540
      TabIndex        =   10
      Top             =   600
      Width           =   4155
      _ExtentX        =   7329
      _ExtentY        =   9763
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   3
      RightMargin     =   20000
      TextRTF         =   $"frmIniFile.frx":0000
   End
   Begin VB.TextBox Text3 
      Height          =   1455
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   8
      Top             =   600
      Width           =   6255
   End
   Begin VB.TextBox Text2 
      Height          =   315
      Left            =   3420
      TabIndex        =   3
      Top             =   5760
      Width           =   2955
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   3420
      TabIndex        =   2
      Top             =   5160
      Width           =   2955
   End
   Begin VB.ListBox lbxKeys 
      Height          =   2400
      Left            =   3420
      TabIndex        =   1
      Top             =   2460
      Width           =   2955
   End
   Begin VB.ListBox lbxSections 
      Height          =   2985
      Left            =   120
      TabIndex        =   0
      Top             =   2460
      Width           =   3075
   End
   Begin VB.Label Label7 
      Caption         =   "Comments zur Section"
      Height          =   195
      Left            =   180
      TabIndex        =   12
      Top             =   5580
      Width           =   1695
   End
   Begin VB.Label Label6 
      Caption         =   "Inhalt Inifile"
      Height          =   195
      Left            =   6660
      TabIndex        =   11
      Top             =   360
      Width           =   1155
   End
   Begin VB.Label Label5 
      Caption         =   "Comments zur IniFile"
      Height          =   195
      Left            =   240
      TabIndex        =   9
      Top             =   360
      Width           =   2115
   End
   Begin VB.Label Label4 
      Caption         =   "Sections"
      Height          =   195
      Left            =   180
      TabIndex        =   7
      Top             =   2220
      Width           =   1815
   End
   Begin VB.Label Label3 
      Caption         =   "Keys"
      Height          =   195
      Left            =   3480
      TabIndex        =   6
      Top             =   2220
      Width           =   2115
   End
   Begin VB.Label Label2 
      Caption         =   "Comment"
      Height          =   195
      Left            =   3420
      TabIndex        =   5
      Top             =   5520
      Width           =   2235
   End
   Begin VB.Label label1 
      Caption         =   "Value"
      Height          =   195
      Left            =   3420
      TabIndex        =   4
      Top             =   4920
      Width           =   2175
   End
   Begin VB.Menu mvarIniFile 
      Caption         =   "IniFile"
      Begin VB.Menu mvarWriteSection 
         Caption         =   "Write Section"
      End
      Begin VB.Menu mnuSectionRename 
         Caption         =   "Rename Section"
      End
      Begin VB.Menu mnuSectionRemove 
         Caption         =   "Remove Section"
      End
      Begin VB.Menu mnu1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuWriteProfile 
         Caption         =   "Write Profile"
      End
      Begin VB.Menu mnuProfileRename 
         Caption         =   "Rename Profile"
      End
      Begin VB.Menu mnuProfileRemove 
         Caption         =   "Remove Profile"
      End
      Begin VB.Menu mnu2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuWriteIniFile 
         Caption         =   "Write IniFile"
      End
   End
End
Attribute VB_Name = "frmIniFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-----------------------------------------------
'
'  frmIniFile     Form zur Demo clsIniFile
'
'  Autor          peter.k.sauer@web.de
'  Created        08.02.2004
'  Update         09.02.2004
'-----------------------------------------------

Option Explicit

Private cIni As clsIniFile

Private Sub Form_Load()
      
   Dim ErrDescription As String
   Dim ErrNumber As Long
   Dim s() As String, Path As String
   Dim i As Long
   
      Set cIni = New clsIniFile
      'automatische Sicherung bei Terminate der Klasse
      'wenn nderungen durchgefhrt
      
      'cIni.AutoSave = True
      
      Path = App.Path
      If Right$(Path, 1) <> "\" Then
         Path = Path & "\"
      End If
      Path = Path & "Test.Ini"
      
      'IniFile einlesen
      If Not cIni.IniFileRead(Path, ErrNumber, ErrDescription) Then
         Me.Show
         MsgBox "Fehler " & ErrNumber & vbCrLf & vbCrLf & _
                ErrDescription
      Else
         ShowIniFile
      End If
      
End Sub

Private Sub Form_Unload(Cancel As Integer)

   Dim Msg As String
   
      Msg = "IniFile wurde gendert" & vbCrLf & vbCrLf & _
            "nderungen speichern ? " & Space(10)
      If cIni.Changed Then
         Msg = "IniFile wurde gendert" & vbCrLf & vbCrLf & _
               "nderungen speichern ? " & Space(10)
         If vbYes = MsgBox(Msg, vbYesNo Or vbQuestion, "Update IniFile") Then
            cIni.IniFileWrite
         End If
      End If
      
      Set cIni = Nothing
End Sub

Private Sub lbxKeys_Click()

   Dim Section As String, Key As String, Comment As String
   
      Section = lbxSections.List(lbxSections.ListIndex)
      Key = lbxKeys.List(lbxKeys.ListIndex)
      'Value eines Profiles ermitteln
      Text1.Text = cIni.GetProfile(Section, Key, Comment, "Defaultwert")
      Text2.Text = Comment
End Sub

Private Sub lbxSections_Click()

   Dim SectionName As String

      Text1.Text = ""
      Text2.Text = ""
      Text4.Text = ""
      
      With lbxSections
         SectionName = .List(.ListIndex)
         'alle Keys einer Section ermitteln und anzeigen
         cIni.GetSectionProfileKeys SectionName, lbxKeys
         
         'Anzahl der Profiles ermitteln
         Label3.Caption = cIni.GetProfileCount(SectionName) & " Profiles/Keys"
         
         'Comments anzeigen
         Text4.Text = cIni.GetSectionComments(SectionName)
      End With
End Sub

'IniFile schreiben
Private Sub mnuIniFileWrite_Click()

      cIni.IniFileWrite
End Sub

'Profile lschen
Private Sub mnuProfileRemove_Click()
   
   Dim i As Long
   Dim SectionName As String, Key As String, Msg As String
   
      i = lbxSections.ListIndex
      SectionName = lbxSections.List(i)
      i = lbxKeys.ListIndex
      Key = lbxKeys.List(i)
      
      Msg = "Key " & Key & Space(10) & vbCrLf & _
            "lschen ?"
      If vbNo = MsgBox(Msg, vbYesNo Or vbQuestion, "Remove Profile") Then
         Exit Sub
      End If
      
      cIni.RemoveProfile SectionName, Key
      ShowIniFile
End Sub

'Profile umbenennen
Private Sub mnuProfileRename_Click()

   Dim i As Long
   Dim Msg As String, SectionName As String
   Dim OldKey As String, NewKey As String
   
      i = lbxKeys.ListIndex
      
      OldKey = lbxKeys.List(i)
      Msg = "Profile(Key) " & OldKey & vbCrLf & vbCrLf & _
            "umbenennen in"
      NewKey = InputBox(Msg, "RenameProfile", OldKey)
      If Len(Trim(NewKey)) = 0 Then
         Exit Sub
      End If
      
      i = lbxSections.ListIndex
      SectionName = lbxSections.List(i)
      cIni.RenameProfile SectionName, OldKey, NewKey
      ShowIniFile
End Sub

Private Sub mnuSectionRemove_Click()
   
   Dim i As Long
   Dim SectionName As String, Msg As String
   
      i = lbxSections.ListIndex
      SectionName = lbxSections.List(i)
      
      Msg = "Section " & SectionName & Space(10) & vbCrLf & _
            "lschen ?"
      If vbNo = MsgBox(Msg, vbYesNo Or vbQuestion, "Remove Section") Then
         Exit Sub
      End If
      
      cIni.RemoveSection SectionName
      ShowIniFile
End Sub

'Section umbenennen
Private Sub mnuSectionRename_Click()
   
   Dim i As Long
   Dim Msg As String
   Dim OldName As String, NewName As String
   
      i = lbxSections.ListIndex
      OldName = lbxSections.List(i)
      
      Msg = "Section " & OldName & vbCrLf & vbCrLf & _
            "umbenennen in"
      NewName = InputBox(Msg, "RenameSection", OldName)
      If Len(Trim(NewName)) = 0 Then
         Exit Sub
      End If
      
      cIni.RenameSection OldName, NewName
      ShowIniFile
End Sub

Private Sub mnuWriteProfile_Click()

   Dim Section As String, Key As String
   Dim Value As String, Comment As String
   
      Randomize
      Section = "New Section " & Int(Rnd * 2)
      Key = "Key" & Int(Rnd * 10)
      Value = "Wert" & Int(Rnd * 10)
      Comment = "angelegt: " & Format(Now, "dd.mm.yyyy hh:nn:ss")

      'ein neues Profile anlegen
      cIni.WriteProfile Section, Key, Value, Comment
      ShowIniFile
End Sub

Private Sub mvarWriteSection_Click()

      'eine neue Section anlegen
      Randomize
      cIni.WriteSection "New Section " & Int(Rnd * 10)
      ShowIniFile
End Sub

Private Sub ShowIniFile()

   Dim i As Long
   Dim s() As String
   
      'Inhalt der IniFile anzeigen
      RichTextBox1.Text = cIni.IniFileString
      
      'Sections ermitteln und anzeigen
      s() = cIni.GetSectionsNames(lbxSections)
      
      'Anzahl der Sections anzeigen
      Label4.Caption = cIni.SectionsCount & " Sections"
      
      'Kommentare anzeigen
      Text3.Text = cIni.IniFileComments
      
      '1. Section Profiles/Keys anzeigen
      If lbxSections.ListCount > 0 Then
         lbxSections.ListIndex = 0
         '1. Value vom Profile anzeigen
         If lbxKeys.ListCount > 0 Then
            lbxKeys.ListIndex = 0
         End If
      End If
         
         'zur Kontrolle: auslesen Array mit Sections
'         For i = LBound(s) To UBound(s)
'            Debug.Print s(i)
'         Next
End Sub
